package fxMMKurssit;

//import fi.jyu.mit.fxgui.ModalController;

import java.net.URL;
import java.util.List;
import java.util.ResourceBundle;

import fi.jyu.mit.fxgui.CheckBoxChooser;
import fi.jyu.mit.fxgui.Dialogs;
import fi.jyu.mit.fxgui.ListChooser;
import fi.jyu.mit.fxgui.ModalController;
import javafx.application.Platform;
import javafx.event.ActionEvent;
import javafx.fxml.FXML;
import javafx.fxml.FXMLLoader;
import javafx.fxml.Initializable;
import javafx.scene.Node;
import javafx.scene.Parent;
import javafx.scene.Scene;
import javafx.scene.control.Button;
import javafx.scene.control.CheckBox;
import javafx.scene.control.Label;
import javafx.scene.control.TextField;
import javafx.stage.Modality;
import javafx.stage.Stage;
import mmkurssit.Kurssi;
import mmkurssit.MMKurssit;
import mmkurssit.SailoException;
import mmkurssit.Tapaaminen;


/**
 * @author aichi
 * @version 5.2.2025
 *
 */
public class MMKurssitGUIController implements Initializable {
    
//Attribuutit===================================================================

    @FXML    private ListChooser<Kurssi> allCourses;

    @FXML    private Button buttonAddMeeting;
    @FXML    private Button buttonOpenMeeting;
    @FXML    private Button close_button;
    @FXML    private Button avaaKurssiTiedot;


    @FXML    private CheckBox onlyUpcoming;

    @FXML    private Label sectionTitle;

    @FXML    private CheckBoxChooser<Kurssi> selectedCourse;

    @FXML    private ListChooser<Tapaaminen> tapaamiset;

    @FXML    private TextField textSearch;

   //===============================================
    
    private MMKurssit mmkurssit;
    private String hakemisto = "tiedot";
    
//==============================================================================   

    @FXML private void addMeeting() {    addTapaaminen();    }
     
    
    @FXML private void openMeetingInfo(ActionEvent event) {
        
        /*Tapaaminen valittu = tapaamiset.getSelectedObject();
        TapaaminenTiedotGUIController.tapaaminenTiedot(null, valittu);*/
        try {
            FXMLLoader fxmlLoader = new FXMLLoader(getClass().getResource("TapaaminenTiedotGUIView.fxml"));
            Parent root2 = (Parent) fxmlLoader.load();
            
            TapaaminenTiedotGUIController controller = fxmlLoader.getController();
            controller.setMMKurssitGUIController(this);
            
            Tapaaminen tap = tapaamiset.getSelectedObject();
            controller.setValittuTap(tap);
            
            Stage stage = new Stage();
            stage.setScene(new Scene(root2));
            stage.setTitle("Meeting Info");
            stage.initModality(Modality.WINDOW_MODAL);//set the modality for the new window
            stage.initOwner(((Node)event.getSource()).getScene().getWindow());//"The new window belongs to this main winodw"
            
            stage.showAndWait();
        } catch(Exception e) {
            System.err.println(e.getMessage());
        }
    }
        
    
    @FXML private void addCourse() {
            addKurssi();
            
            Kurssi k = new Kurssi();
            KurssinlisaysGUIController.uusiKurssi(null, k); //null = modallinen koko ohjelmalle
            //ModalController.showModal(MMKurssitGUIController.class.getResource("KurssinlisaysGUIView.fxml"), "New course", null, k);
            
        }
    


    @FXML private void openCourseList() {
        //
    }
    
    @FXML private void checkCourseInfo() {
        
        Kurssi valittu = allCourses.getSelectedObject();
        KurssinTiedotGUIController.kurssinTiedot(null, valittu);
        /*try {
            FXMLLoader fxmlLoader = new FXMLLoader(getClass().getResource("KurssinTiedotGUIView.fxml"));
            Parent root4 = (Parent) fxmlLoader.load();
            Stage stage = new Stage();
            stage.setTitle("Course Info");
            stage.setScene(new Scene(root4));
            stage.show();
        } catch (Exception e) {
            Dialogs.showMessageDialog("Cannot open the infoS");
        }*/
    }

    
    /**
     * Uncheck all the selected courses
     */
    @FXML private void resetSelected() {
        //
    }
    
    
    /**
     * If a user check this checkbox, show only the upcoming meetings on the list
     */
    @FXML private void showUpcomingMeetingsOnly() {
        //
    }
    
    
    @FXML private void refreshWindow() {
        //
    }
    
    @FXML private void closeProgram() { //TODO: Confirmation modal message before save and exit
        try {
            mmkurssit.tallenna(hakemisto);
        } catch (SailoException e) {
            Dialogs.showMessageDialog(e.getMessage());
        }
        Platform.exit();
    }
//===================================================================================

    /**
     * Asetetaan käytettävä mmkurssit (aktivoitu MMKurssitMain:lla),
     * luetaan tiedostosta aikaisemnin lisätyt kurssit ja 
     * laitetaan ne allCourse-kohdalle
     * @param mmkurssit jota käytetään
     */
    public void setMMKurssit(MMKurssit mmkurssit) {
        this.mmkurssit = mmkurssit;
        lueTiedosto();
        naytaKurssit();
    }
    
    
    /**
     * HUOM!! Tämä metodi aktivoituu jopa ennen varsinaisen MMKurssit-olion luomista,
     * Älä laita mitään metodia, joka käsittelee mmkurssit.
     */
    @Override
    public void initialize (URL arg0, ResourceBundle arg1) {
        alusta();
    }
    
    //=========
    
    /**
     * Alustetaan ohjelman asetukset 
     */
    private void alusta() {
        allCourses.clear();
        tapaamiset.clear();

        allCourses.setOnMouseClicked(event -> {
            Kurssi selectedK = allCourses.getSelectedObject();
            haeTapaaminen(selectedK.getID());
        });
    }
    
    
    /**
     * Näytetään kaikki kurssit, jotka ovat lisätty ja tallennettu
     */
    private void naytaKurssit() {
     
        for (int i= 0; i<mmkurssit.getKurssienKpl(); i++) { 
            Kurssi k = mmkurssit.annaKurssi(i);                     
            allCourses.add(""+k.getNimi(), k);
        }
    }


    /**
     * @return virhe string jos lukeminen epäonnistuu
     */
    protected String lueTiedosto() {//TODO: (String uusi) {
       
       //hakemisto = uusi;
        
       try {
            mmkurssit.lueTiedostosta(hakemisto);
            return null;
        } catch (SailoException e) {
            String virhe = e.getMessage();
            if (virhe != null) Dialogs.showMessageDialog(e.getMessage());
            return virhe;
        }
        
    }


    /**
     * Lisätään mmkurssille uusi kurssi
     */
    private void addKurssi() {
        Kurssi uusi = new Kurssi();
        uusi.rekisteroi();
        uusi.tayta();
        
        try {
            mmkurssit.lisaa(uusi);
        } catch (SailoException e) {
            Dialogs.showMessageDialog("Ongelmia uuden kurssin luomisessa" + e.getMessage());
        }
        haeKurssi(uusi.getID());
    }

    
    /**
     * Haetaan kurssia
     * @param nro kurssin ID, joka valitaan
     */
    private void haeKurssi(int nro) {
        allCourses.clear();
        
        int indeksi = 0;
        for (int i= 0; i<mmkurssit.getKurssienKpl(); i++) { //käydään läpi kaikki kurssit
            Kurssi k = mmkurssit.annaKurssi(i);             //otetaan 1 kurssi kerrallaan
            if (k.getID() == nro) indeksi = i;              
            allCourses.add(""+k.getNimi(), k);
        }
        allCourses.setSelectedIndex(indeksi);
    }
    
    
    /**
     * Lisätään uusi tapaaminen valitulle kurssille
     */
    private void addTapaaminen() {
        
        Kurssi selectedK = allCourses.getSelectedObject();
        if (selectedK == null) return;
        Tapaaminen tap = new Tapaaminen(selectedK.getID());//väkisin nyt kaikki tapaamisien kurssiID on 1, myöhemmin korjattava!
        tap.rekisteroi();
        tap.tayta();
        
        mmkurssit.lisaa(tap);
        
        haeTapaaminen(selectedK.getID());
    }

    
    /**
     * Haetaan kaikki tapaamiset, jotka ovat kytketty valitulle kurssille
     * @param kurssiID valittu kurssin ID
     */
    private void haeTapaaminen(int kurssiID) {
        tapaamiset.clear();//laitetaan tyhjäksi eka
        
        List<Tapaaminen> lista1 = mmkurssit.annaTapaamiset(kurssiID);//saadaan lista, jossa on kaikki tapaamiset, jotka liittyy samaan kurssiin
        
        int indeksi = 0;
        //Interator<Tapaaminen> iter = lista1.iterator(); iter.hasNext();...
        for (int i=0; i<lista1.size(); i++) {
            Tapaaminen t = lista1.get(i);
            indeksi = i;
            tapaamiset.add(""+t.getRadNro()+" "+t.milloin()+" "+t.aloitusaika(), t);
        }
        tapaamiset.setSelectedIndex(indeksi);
    }


    /**
     * @param tap valittu tapaaminen
     * @return Kurssi, mihin tapaaminen on kytketty kurssiID-attribuutin avulla
     */
    public Kurssi mihinKurssiin(Tapaaminen tap) {
        if (tap == null) return null;
        
        int kID = tap.getkID();
        Kurssi kurssi = mmkurssit.annaKurssi(kID);
        return kurssi;
    }
    
      
}